;;;
;;; Copyright (c) 1990 Regents of the University of California
;;; 
;;; $Author: bsmith $
;;; $Source: /pic2/picasso/new/toolkit/borders/standout-border.cl,v $
;;; $Revision: 1.1 $
;;; $Date: 1991/08/04 19:02:43 $
;;;

(in-package "PT")

;; a standout border makes something stand out

(defmethod border-init ((border (eql :standout)) self &aux sup) 
  (setq sup (parent self))
  (setf (xlib:drawable-border-width (res self)) 0)
  (setf (slot-value self 'intern-border-gcs) 
	(cons (make-shared-gc sup '(:background "white" :foreground "black"))
	      (make-shared-gc sup '(:foreground "white"))))
  (setf (slot-value self 'border-width) 2))

(defmethod border-repaint ((border (eql :standout)) self 
			   &aux gcs bw w h sup )
  (setq gcs (slot-value self 'intern-border-gcs)
	bw (slot-value self 'border-width)
	sup (parent self))
  (if (listp bw) 
      (setq w (car bw) h (cadr bw))
      (setq w bw h bw))
  (draw-outer-border self (car gcs) (cdr gcs) :x-width w :y-width h))

(defmethod border-clear ((border (eql :standout)) self &aux bw x y w h sup)
  (setq bw (border-width self)
	sup (parent self))
  (if (listp bw) 
      (setq x (car bw) y (cadr bw) w (third bw) h (fourth bw))
      (setq x bw y bw w bw h bw))
  (clear-region (parent self) 
		(+ (repaint-x sup) (x-offset self) (- x))
		(+ (repaint-y sup) (y-offset self) (- y))
		(+ (width self) x w)
		(+ (height self) y h)))
